using System;

namespace Steganography
{
	public class Stego
	{
		
		public static void Main(string[] args) 
		{
			
			try 
			{
				// Encoding
				if (args[0].Equals("-e"))
					Encode(args[1], args[2], args[3], args[4]);
				
				// Decoding
				else if (args[0].Equals("-d"))
					Decode(args[1], args[2]);							
					
				else				
					Syntax();
			} 
			catch (IndexOutOfRangeException)
			{
				Syntax();
			}
			catch (Exception e)
			{
				Console.WriteLine(e.Message);
			}
									
		} 
		
		
		private static void Encode(string fileName, string message, 
			string password, string outFileName)
		{
			// Open the cover
			ICoverFile cover = new BMPCoverFile(fileName);
			
			// Create the stego file
			cover.CreateStegoFile(outFileName, message, password);			
		}
		
		private static void Decode(string fileName, string password)
		{
			// Open the stego file
			IStegoFile stego = new BMPStegoFile(fileName, password);			
			
			// Show the hidden text
			Console.WriteLine(stego.HiddenMessage);
		}
		
		private static void Syntax() 		
		{
			Console.WriteLine("Syntax: Stego [-e <fileToEncode> <message> <password> <outFile>]");
			Console.WriteLine("            | [-d <fileToDecode> <password>]");
			Environment.Exit(0);
		}
				
		
	}
	
}
